Remove overrides that inserts a non-breaking space (nbsp) to empty option elements
2024-02-08 08:05 - Mizuki ISHIKAWA
Description

In Redmine forms, a problem occurs where the "blank" option does not appear in select box fields (e.g., Version or Category). The
blank option is visible when the default value is blank, such as in the new issue form. However, if a non-blank value is selected,
saved, and then the edit issue form is reloaded, the blank option is missing from the select box.

Example 1: After changing the category value from blank to another value and registering the issue, when you attempt to change the
category back to blank in the edit form, the blank option is missing from the category select box.

Example 2: Similarly, when creating a new issue with a default version set in the project settings, if you try to set the version back to
blank, the blank option is missing from the version select box.

Despite the f.selectbox being configured with include_blank: true, it does not seem to function properly. This issue does not occur in
the Redmine 5.1-stable version and is observed only in the trunk version.

Related issues:
Related to Redmine - Feature #36320: Migrate to Rails 7.1 Reopened
Related to Redmine - Defect #25337: Redmine patch for Rails breaks functional... Closed

Associated revisions

Revision 22701 - 2024-02-10 11:28 - Marius BALTEANU

Remove overrides that inserts a non-breaking space (nbsp) to empty option elements (#40210).

Patch by Go MAEDA (maeda).

History

#1 - 2024-02-08 08:29 - Go MAEDA
- File clipboard-202402081626-rfc6i.png added

- Status changed from New to Confirmed

| have confirmed the issue. In the following screenshot, you cannot set the assignee field to blank.
#2 - 2024-02-08 09:11 - Mizuki ISHIKAWA

It appears to be affected by the changes made to config/initializers/10-patches.rb in r22488 (

https://github.com/redmine/redmine/commit/7b911245d31509da8fa656bbedc37213d3148897 ?diff=unified&w=0#diff-3df1b8f50fcd1f2fcef72d0bae0d0
30cc1chdad45c63achd1722b4c6fa98c7f6R55-L83 ) .

The problem can be fixed by making the following change.

diff --git a/config/initializers/10-patches.rb b/config/initializers/10-patches.rb
index 1d932eblf..6024e8c8d 100644
-—- a/config/initializers/10-patches.rb
+++ b/config/initializers/10-patches.rb
Q@ -41,7 +41,7 QR module ActionView

SelectRenderer.prepend (Module.new do

def add_options (option_tags, options, value = nil)
if options.delete (:include_blank)

= options[:prompt] = '&nbsp;'.html_safe

+ options[:include_blank] = 'é&nbsp;'.html_safe
end
super

end
https://www.redmine.org/projects/redmine/repository/svn/revisions/22488
https://github.com/redmine/redmine/commit/7b911245d31509da8fa656bbedc37213d3148897?diff=unified&w=0#diff-3df1b8f50fcd1f2fcef72d0bae0d030cc1c5dad45c63acbd1722b4c6fa98c7f6R55-L83
https://github.com/redmine/redmine/commit/7b911245d31509da8fa656bbedc37213d3148897?diff=unified&w=0#diff-3df1b8f50fcd1f2fcef72d0bae0d030cc1c5dad45c63acbd1722b4c6fa98c7f6R55-L83

#3 - 2024-02-08 09:28 - Go MAEDA
- Related to Feature #36320: Migrate to Rails 7.1 added

#4 - 2024-02-09 04:36 - Go MAEDA
- File dont-insert-nbsp-to-blank-option-element.patch added
| am beginning to question the necessity of the code that inserts a non-breaking space (nbsp) to empty option elements.

The code was added in r12237. The purpose of the change was to fix HTML5 validation failures pointed out in #15191. However, | have not found any
evidence that empty option elements violate HTML5 standards.

| tested the following HTML, which contains an empty option element (<option value="" label=""></option>), using the Nu Html Checker by W3C and
the test passed without any errors.

<!DOCTYPE html>
<html lang="en">

<head>

<title>test</title>

</head>

<body>

<select name="issue|[category_id]" id="issue_category_id"><option value="" label=" "></option>

<option selected="selected" value="1">Printing</option>
<option value="2">Recipes</option></select>

</body>

</html>

Additionally, | checked the MDN documentation and still could not find any mention of an empty option element being prohibited.

| believe the Rails team should have improved the form helper to insert nbsp when :include_blank is passed if it violates HTMLS standards, but such
enhancement has not occured even 10 years after r12237 was committed. In my opinion, this suggests that the Rails team does not consider empty
option elements are disallowed.

Based on the above, | propose to delete the code to insert nbsp to every blank option element.

#5 - 2024-02-09 05:28 - Mizuki ISHIKAWA

Based on the above, | propose to delete the code to insert nbsp to every blank option element.

I'm in favor of it.

#6 - 2024-02-09 14:05 - Marius BALTEANU
- Assignee set to Marius BALTEANU

#7 - 2024-02-10 11:29 - Marius BALTEANU
- Tracker changed from Defect to Patch

- Subject changed from Blank option not included in selectbox options when a non-blank value is selected to Remove overrides that inserts a
non-breaking space (nbsp) to empty option elements

- Category set to Code cleanup/refactoring
- Status changed from Confirmed to Resolved

- Target version set to 6.0.0

#8 - 2024-02-11 01:00 - Go MAEDA
- Related to Defect #25337: Redmine patch for Rails breaks functionality of select_tag added

#9 - 2024-02-13 23:37 - Marius BALTEANU

- Status changed from Resolved to Closed

Files
clipboard-202402081626-rfc6i.png 113 KB 2024-02-08 Go MAEDA
dont-insert-nbsp-to-blank-option-element.patch 2.53 KB 2024-02-09 Go MAEDA
